from functools import wraps

from flask import request, render_template
from . import config

# FIXME: EVERYTHING is under the auth now, even files (makes sense)
#        but that means that even the favicon requires authentication.


def auth_page(*args, **kwargs):
    # TODO: Is there a better way of doing this?
    path = f"{request.path}?{request.query_string.decode('utf-8')}"

    return render_template("auth.html", path=path), 403


def requires_auth(f):
    @wraps(f)
    def decorated(*args, **kwargs):
        if config.get('password') in [False, None, ""]:
            return f(*args, **kwargs)

        if request.cookies.get('film_session', None) != 'To be changed':
            # Not authenticated
            return auth_page()

        # User properly authenticated
        print(request.cookies['film_session'])
        return f(*args, **kwargs)

    return decorated
